var fnqueue = require('../lib/fnqueue');

// using with functions

var worker = fnqueue(function(a, b, cb){
    console.log('IN WORKER: a=', a, 'b=', b);

    // do some async work and then call the callback:

    setTimeout(function(){
        cb(a + b);
    }, 2000)

})

// now call the function as many times as you need - the worker will run in series processing its queue

worker(1, 2, function(sum){
    console.log('CALLBACK 1: sum=', sum);
})

worker(10, 20, function(sum){
    console.log('CALLBACK 2: sum=', sum);
})
