var fnqueue = require('../lib/fnqueue');

// using fnqueue with object methods

var obj = {
    text: 'hello',

    worker: fnqueue(function(a, b, cb){
        console.log('IN WORKER: a=', a, 'b=', b, 'this=', this);

        // do some async work and then call the callback:

        setTimeout(function(){
            cb(a + b);
        }, 2000)

    })
}

// now call the method as many times as you need - the worker will run in series processing its queue

obj.worker(1, 2, function(sum){
    console.log('CALLBACK 1: sum=', sum);
})

obj.worker(10, 20, function(sum){
    console.log('CALLBACK 2: sum=', sum);
})
